summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRobin H. Johnson <robbat2@gentoo.org>2015-08-08 13:49:04 -0700
committerRobin H. Johnson <robbat2@gentoo.org>2015-08-08 17:38:18 -0700
commit56bd759df1d0c750a065b8c845e93d5dfa6b549d (patch)
tree3f91093cdb475e565ae857f1c5a7fd339e2d781e /www-apps/webdavcgi
downloadgentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.gz
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.bz2
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.zip
proj/gentoo: Initial commit
This commit represents a new era for Gentoo: Storing the gentoo-x86 tree in Git, as converted from CVS. This commit is the start of the NEW history. Any historical data is intended to be grafted onto this point. Creation process: 1. Take final CVS checkout snapshot 2. Remove ALL ChangeLog* files 3. Transform all Manifests to thin 4. Remove empty Manifests 5. Convert all stale $Header$/$Id$ CVS keywords to non-expanded Git $Id$ 5.1. Do not touch files with -kb/-ko keyword flags. Signed-off-by: Robin H. Johnson <robbat2@gentoo.org> X-Thanks: Alec Warner <antarus@gentoo.org> - did the GSoC 2006 migration tests X-Thanks: Robin H. Johnson <robbat2@gentoo.org> - infra guy, herding this project X-Thanks: Nguyen Thai Ngoc Duy <pclouds@gentoo.org> - Former Gentoo developer, wrote Git features for the migration X-Thanks: Brian Harring <ferringb@gentoo.org> - wrote much python to improve cvs2svn X-Thanks: Rich Freeman <rich0@gentoo.org> - validation scripts X-Thanks: Patrick Lauer <patrick@gentoo.org> - Gentoo dev, running new 2014 work in migration X-Thanks: Michał Górny <mgorny@gentoo.org> - scripts, QA, nagging X-Thanks: All of other Gentoo developers - many ideas and lots of paint on the bikeshed
Diffstat (limited to 'www-apps/webdavcgi')
-rw-r--r--www-apps/webdavcgi/Manifest2
-rw-r--r--www-apps/webdavcgi/files/0.8.3-logout-var-expansion.patch21
-rw-r--r--www-apps/webdavcgi/files/apache-webdavcgi-0.8-example.conf59
-rw-r--r--www-apps/webdavcgi/files/postinstall-en.txt29
-rw-r--r--www-apps/webdavcgi/files/postinstall-webdavwrapper-en.txt32
-rwxr-xr-xwww-apps/webdavcgi/files/reconfig32
-rwxr-xr-xwww-apps/webdavcgi/files/reconfig-suid26
-rw-r--r--www-apps/webdavcgi/files/webdav-0.8.conf88
-rw-r--r--www-apps/webdavcgi/metadata.xml28
-rw-r--r--www-apps/webdavcgi/webdavcgi-0.8.3.ebuild108
-rw-r--r--www-apps/webdavcgi/webdavcgi-0.8.4.ebuild164
11 files changed, 589 insertions, 0 deletions
diff --git a/www-apps/webdavcgi/Manifest b/www-apps/webdavcgi/Manifest
new file mode 100644
index 00000000000..a60eeb13801
--- /dev/null
+++ b/www-apps/webdavcgi/Manifest
@@ -0,0 +1,2 @@
+DIST webdavcgi-0.8.3.tar.bz2 1190975 SHA256 d8ca7feb1f25f6acce67a5ea769a089edd404660c85633dfbd6303696f1cd294 SHA512 f50e6bb1e78a88ab6bc6452c04f2e5d0cec86f6641d1813556ae3b06c33e2c9250e623926bf1a71ea10f6ca3912e708cb54cd0956b344329de1499887e48e784 WHIRLPOOL e05d0b2e5d6905d3c86e807c1f6b7544c1fa9629f310496648088c2a1a5bb491e507e492b80fa4beb6ab43f9f1d1bbfd095d1b670e3ca88e89b3605f5d790743
+DIST webdavcgi-0.8.4.tar.bz2 1195935 SHA256 d04438a515a770502117b4219ebb5406ed1ab949420802d0ce623fe3f61038ef SHA512 17d9dcfe68012820bf809bc3bd54a881fc9e66a9ddfd87d9381ec0cb08abe3f81638afba4d28ab3079ed56cf1e263b4a764b8348691f17a06743bb1ddf3a2a4e WHIRLPOOL 86d65aad94cd6461f72c39d39f1beb0c24b049a50072ef3b4e16629b388ec562136ee0cb2f93674eaf9342feac077540e98f78b22ad186cf4592cf8d53cbc530
diff --git a/www-apps/webdavcgi/files/0.8.3-logout-var-expansion.patch b/www-apps/webdavcgi/files/0.8.3-logout-var-expansion.patch
new file mode 100644
index 00000000000..739ff7f4c79
--- /dev/null
+++ b/www-apps/webdavcgi/files/0.8.3-logout-var-expansion.patch
@@ -0,0 +1,21 @@
+diff -ru cgi-bin.orig/logout-dist cgi-bin/logout-dist
+--- cgi-bin.orig/logout-dist 2011-03-22 17:25:52.000000000 +0100
++++ cgi-bin/logout-dist 2012-10-03 21:44:35.057437306 +0200
+@@ -34,13 +34,13 @@
+ # -----
+ ### REALM: the basic authentication realm
+ ### (must be equal to your AuthName value for Apache)
+-REALM="Change Me"
++REALM="${REALM:=Change Me}"
+
+ ### HOMEURL: the home URL
+-HOMEURL="/changemyhomeurl"
++HOMEURL="${HOMEURL:=/changemyhomeurl}"
+
+-### TIMEOUT: the refresh timeout for the logut page
+-TIMEOUT=0
++### TIMEOUT: the refresh timeout for the logout page
++TIMEOUT=${TIMEOUT:=0}
+
+ # SETUP END
+
diff --git a/www-apps/webdavcgi/files/apache-webdavcgi-0.8-example.conf b/www-apps/webdavcgi/files/apache-webdavcgi-0.8-example.conf
new file mode 100644
index 00000000000..58bef75eadb
--- /dev/null
+++ b/www-apps/webdavcgi/files/apache-webdavcgi-0.8-example.conf
@@ -0,0 +1,59 @@
+# Example Apache HTTP server configuration snippet for WebDAV CGI
+#
+# Add the following lines to the Apache HTTP virtual host which should run
+# WebDAV CGI.
+#
+# WebDAV CGI will be accessible via http://www.example.com/webdav/ and uses
+# basic HTTP authentication (by default). For this to work, you need to add all
+# valid users to the AuthUserFile with the help of the htpasswd command:
+#
+# htpasswd -c /etc/webdavcgi-0.8/default/users.htpasswd user1
+# htpasswd /etc/webdavcgi-0.8/default/users.htpasswd user2
+#
+# Note, that if you have the UID/GID wrapper enabled (USE=suid), WebDAV CGI will
+# switch to the login user after a successful login, thus the users within the
+# AuthType need to present on the system as well.
+#
+# You probably want to review and change the following settings:
+# - /webdavcgi should point to your desired webdavwrapper, which is either
+# webdavwrapper, webdavwrapper-afs, webdavwrapper-krb or in case you disabled
+# the UID/GID wrapper (USE=-suid), webdav.pl
+#
+# - The /webdav location
+# If you change this location, make sure to reflect the new path within the
+# WebDAV CGI configuration (WEBDAVCONF -> $VIRTUAL_BASE) as well.
+#
+# - The authentication provider and/or AuthUserFile
+#
+# - The HOMEURL environment variable. After a user logs out, the browser will
+# be redirected to this URL.
+#
+# - The WEBDAVCONF environment variable has to point to your configuration
+#
+# For further informations and other configuration possibilities consult the
+# WebDAV CGI documentation which is located at http://webdavcgi.sourceforge.net
+# and the Apache HTTP server documentation at http://httpd.apache.org/docs/
+#
+ ScriptAlias /webdavcgi "/usr/libexec/webdavcgi-0.8/cgi-bin/webdavwrapper"
+ ScriptAlias /webdav/logout "/usr/libexec/webdavcgi-0.8/cgi-bin/logout"
+
+ <Location /webdav>
+ Order Allow,Deny
+ Allow from all
+ </Location>
+
+ <Location /webdavcgi>
+ AuthType Basic
+ AuthName "WebDAV-CGI"
+ AuthUserFile /etc/webdavcgi-0.8/default/users.htpasswd
+ Require valid-user
+ Order Allow,Deny
+ Allow from all
+ </Location>
+
+
+ RewriteEngine On
+
+ RewriteRule ^/webdav/logout - [L,E=REALM:WebDAV-CGI,E=HOMEURL:/webdav,E=TIMEOUT:5]
+
+ RewriteRule ^/webdav /webdavcgi [PT,L,E=WEBDAVCONF:/etc/webdavcgi-0.8/default/webdav.conf,E=PERLLIB:/usr/share/webdavcgi-0.8/lib/perl,E=LOGOUTURL:/webdav/logout]
diff --git a/www-apps/webdavcgi/files/postinstall-en.txt b/www-apps/webdavcgi/files/postinstall-en.txt
new file mode 100644
index 00000000000..8aa6f95d87a
--- /dev/null
+++ b/www-apps/webdavcgi/files/postinstall-en.txt
@@ -0,0 +1,29 @@
+Before you can run WebDAV CGI you need to configure your web server and WebDAV
+CGI itself.
+
+The following configuration snippet serves as an example for the Apache HTTPD
+web server. You will have to adapt it to suite your own server and configuration
+needs.
+
+ ScriptAlias /cgi-bin/ "${VHOST_CGIBINDIR}/"
+
+ <Location /${VHOST_CGIBINDIR##*/}/>
+ AuthType Basic
+ AuthName "WebDAV-CGI"
+ AuthUserFile ${VHOST_ROOT}/etc/users.htpasswd
+ Require valid-user
+ Order Allow,Deny
+ Allow from all
+ </Location>
+
+ RewriteEngine On
+ RewriteRule ^/${VHOST_APPDIR}/logout /${VHOST_CGIBINDIR##*/}/logout [PT,E=REALM:WebDAV-CGI,E=HOMEURL:/${VHOST_APPDIR},L]
+ RewriteRule ^/${VHOST_APPDIR} /${VHOST_CGIBINDIR##*/}/webdav.pl [PT,E=WEBDAVCONF:${VHOST_ROOT}/etc/webdav.conf,E=PERLLIB:${VHOST_ROOT}/lib/perl,L]
+
+
+Afterwards you need to copy the default configuration file and edit it:
+cp -p ${VHOST_ROOT}/etc/{webdav.conf-dist,webdav.conf}
+\$EDITOR ${VHOST_ROOT}/etc/webdav.conf
+
+For further informations study the online documentation which is located at:
+http://webdavcgi.sourceforge.net/doc.html
diff --git a/www-apps/webdavcgi/files/postinstall-webdavwrapper-en.txt b/www-apps/webdavcgi/files/postinstall-webdavwrapper-en.txt
new file mode 100644
index 00000000000..5f30d81be7b
--- /dev/null
+++ b/www-apps/webdavcgi/files/postinstall-webdavwrapper-en.txt
@@ -0,0 +1,32 @@
+Before you can run WebDAV CGI you need to configure your web server and WebDAV
+CGI itself.
+
+The following configuration snippet serves as an example for the Apache HTTPD
+web server. You will have to adapt it to suite your own server and configuration
+needs.
+
+ ScriptAlias /cgi-bin/ "${VHOST_CGIBINDIR}/"
+
+ <Location /${VHOST_CGIBINDIR##*/}/>
+ AuthType Basic
+ AuthName "WebDAV-CGI"
+ AuthUserFile ${VHOST_ROOT}/etc/users.htpasswd
+ Require valid-user
+ Order Allow,Deny
+ Allow from all
+ </Location>
+
+ RewriteEngine On
+ RewriteRule ^/${VHOST_APPDIR}/logout /${VHOST_CGIBINDIR##*/}/logout [PT,E=REALM:WebDAV-CGI,E=HOMEURL:/${VHOST_APPDIR},L]
+ RewriteRule ^/${VHOST_APPDIR} /${VHOST_CGIBINDIR##*/}/webdavwrapper [PT,E=WEBDAVCONF:${VHOST_ROOT}/etc/webdav.conf,E=PERLLIB:${VHOST_ROOT}/lib/perl,L]
+
+
+Afterwards you need to copy the default configuration file and edit it:
+cp -p ${VHOST_ROOT}/etc/{webdav.conf-dist,webdav.conf}
+\$EDITOR ${VHOST_ROOT}/etc/webdav.conf
+
+Also make sure that all system users which should be able to login to WebDAV CGI
+are able to access the installed files below ${VHOST_ROOT}.
+
+For further informations study the online documentation which is located at:
+http://webdavcgi.sourceforge.net/doc.html
diff --git a/www-apps/webdavcgi/files/reconfig b/www-apps/webdavcgi/files/reconfig
new file mode 100755
index 00000000000..07710dd7c3e
--- /dev/null
+++ b/www-apps/webdavcgi/files/reconfig
@@ -0,0 +1,32 @@
+#!/bin/bash
+
+confDir="etc"
+distConfFile="webdav.conf-dist"
+
+sedCmd="/bin/sed"
+
+
+function die ()
+{
+ echo "reconfig error: $1" >&2
+ exit 1
+}
+
+
+if [ $1 != "install" ]; then
+ # nothing to be done, exit
+ exit 0
+fi
+
+# Set the correct path within the config file
+distConfFilePath="${VHOST_ROOT}/${confDir}/${distConfFile}"
+if ! ${sedCmd} -i -e "s|^\(\$INSTALL_BASE\)=.*|\1='${VHOST_ROOT}/';|" \
+ ${distConfFilePath}
+then
+ die "Setting INSTALL_BASE path in ${distConfFilePath} failed"
+fi
+
+
+# Adding logout support
+# see: http://webdavcgi.sourceforge.net/doc.html#logout
+echo "\$HEADER = '<div class=\"header\">WebDAV CGI - Web interface: You are logged in as <span title="'.`id -a`.'">' .\$ENV{REMOTE_USER}.'</span> (<a href="/logout">Logout</a>).</div>';" >> ${distConfFilePath}
diff --git a/www-apps/webdavcgi/files/reconfig-suid b/www-apps/webdavcgi/files/reconfig-suid
new file mode 100755
index 00000000000..d7fb8772261
--- /dev/null
+++ b/www-apps/webdavcgi/files/reconfig-suid
@@ -0,0 +1,26 @@
+#!/bin/bash
+
+webDavWrapper="webdavwrapper"
+webDavWrapperPath="${VHOST_CGIBINDIR}/${webDavWrapper}"
+
+chmodCmd="/bin/chmod"
+chownCmd="/bin/chown"
+
+
+function die ()
+{
+ echo "reconfig error: $1" >&2
+ exit 1
+}
+
+if [ $1 = "install" ]; then
+ # In order to change the user and group ID at runtime, the webdavwrapper
+ # needs to be run as root (set-user-ID and set-group-ID bit)
+ if ! ${chownCmd} root:root ${webDavWrapperPath}; then
+ die "Chown for ${webDavWrapperPath} failed"
+ fi
+
+ if ! ${chmodCmd} 6755 ${webDavWrapperPath}; then
+ die "Setting SUID and SGID bit on ${webDavWrapperPath} failed"
+ fi
+fi
diff --git a/www-apps/webdavcgi/files/webdav-0.8.conf b/www-apps/webdavcgi/files/webdav-0.8.conf
new file mode 100644
index 00000000000..8563df7ad61
--- /dev/null
+++ b/www-apps/webdavcgi/files/webdav-0.8.conf
@@ -0,0 +1,88 @@
+## -- INSTALL_BASE
+## folder path to the webdav.conf, .css, .js, and. msg files for the Web
+## interface
+## (don't forget the trailing slash)
+$INSTALL_BASE='/usr/share/webdavcgi-0.8/';
+
+## -- VIRTUAL_BASE
+## only neccassary if you use redirects or rewrites from a VIRTUAL_BASE to
+## the DOCUMENT_ROOT;
+## regular expressions are allowed
+## EXAMPLE: $VIRTUAL_BASE = '/';
+$VIRTUAL_BASE = '/webdav';
+
+## -- DOCUMENT_ROOT
+## by default the server document root
+## (don't forget a trailing slash '/'):
+$DOCUMENT_ROOT = '/home/';
+
+## -- UMASK
+## mask for file/folder creation
+## (it does not change permission of existing files/folders):
+$UMASK = 0007;
+
+## -- ENABLE_DAVMOUNT
+## enables DAV mount button in the folder navigation of the Web interface
+$ENABLE_DAVMOUNT = 1;
+
+## -- ENABLE_COMPRESSION
+## enables/disables gzip content encoding for the Web interface
+$ENABLE_COMPRESSION = 0;
+
+## -- PAGE_LIMIT
+## limits number of files/folders shown in the Web interface
+$PAGE_LIMIT=100;
+
+## -- PAGE_LIMITS
+## allowed selectable limits (-1 = show all)
+@PAGE_LIMITS = ( 5, 10, 15, 20, 30, 50, 100, -1);
+
+## -- DBI_(SRC/USER/PASS)
+## database setup for LOCK/UNLOCK/PROPPATCH/PROPFIND data
+##
+## SQLite config
+## If users share the same folder they should use the same database
+## in this case you have to use a single file writeable for all users.
+#$DBI_SRC='dbi:SQLite:dbname=/var/lib/webdavcgi/0.8/default/webdav.db';
+#$DBI_USER='';
+#$DBI_PASS='';
+#$CREATE_DB = !-e '/var/lib/webdavcgi/0.8/default/webdav.db';
+
+## MySQL config
+#$DBI_SRC='DBI:mysql:database=webdavcgi;host=localhost;port=3306';
+#$DBI_USER='mysqluser';
+#$DBI_PASS='changeme';
+#$CREATE_DB=0;
+
+## PostgreSQL config
+#$DBI_SRC='dbi:Pg:dbname=webdavcgi;host=localhost;port=5432';
+#$DBI_USER='pguser';
+#$DBI_PASS='changeme';
+#$CREATE_DB = 0;
+
+## -- HEADER
+## content after body tag in the Web interface
+$HEADER = '<div class="header">WebDAV CGI - Web interface: You are logged in as <span title=.`id -a`.>' .$ENV{REMOTE_USER}.'</span> (<a href="'.$ENV{LOGOUTURL}.'">Logout</a>).</div>';
+
+## -- ENABLE_CALDAV
+## Disable CalDAV support for Lightning/Sunbird/iCal/iPhone calender/task
+## support
+$ENABLE_CALDAV = 0;
+
+## -- ENABLE_GROUPDAV
+## Disables GroupDAV (http://groupdav.org/draft-hess-groupdav-01.txt)
+$ENABLE_GROUPDAV = 0;
+
+## -- ENABLE_THUMBNAIL
+## Disable image thumbnail support and media rss feed for folder listings of the
+## Web interface.
+## If enabled the default icons for images will be replaced by thumbnails
+## and if the mouse is over a icon the icon will be zoomed to the size of
+## $THUMBNAIL_WIDTH.
+$ENABLE_THUMBNAIL = 0;
+
+## -- THUMBNAIL_CACHEDIR
+## defines the path to a cache directory for image thumbnails
+## this is neccessary if you enable the thumbnail cache ($ENABLE_THUMBNAIL_CACHE)
+## EXAMPLE: $THUMBNAIL_CACHEDIR=".thumbs";
+$THUMBNAIL_CACHEDIR="/var/cache/webdavcgi/0.8/default/thumbnails";
diff --git a/www-apps/webdavcgi/metadata.xml b/www-apps/webdavcgi/metadata.xml
new file mode 100644
index 00000000000..69dfa868c9f
--- /dev/null
+++ b/www-apps/webdavcgi/metadata.xml
@@ -0,0 +1,28 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <herd>proxy-maintainers</herd>
+ <maintainer>
+ <email>christian.affolter@stepping-stone.ch</email>
+ <description>Maintainer</description>
+ </maintainer>
+ <maintainer>
+ <email>dev-zero@gentoo.org</email>
+ <description>Proxy maintainer</description>
+ </maintainer>
+ <longdescription>
+ WebDAV CGI is a Perl CGI script that enables the WebDAV protocol
+ (class 1,2,3) for Web server to manage Web sites or to use a Web server
+ as a Web drive for files, or for calendar/addressbook sharing. If you
+ need correct permissions for files and folders you can install this
+ WebDAV CGI script and a UID/GID wrapper. The Apache module mod_dav does
+ not support UID/GID wrapping, so this implementation fills up this gap
+ as a complete replacement.
+ </longdescription>
+ <use>
+ <flag name="rcs">Adds support for a revision controlled backend with RCS (<pkg>dev-vcs/rcs</pkg>)</flag>
+ </use>
+ <upstream>
+ <remote-id type="sourceforge">webdavcgi</remote-id>
+ </upstream>
+</pkgmetadata>
diff --git a/www-apps/webdavcgi/webdavcgi-0.8.3.ebuild b/www-apps/webdavcgi/webdavcgi-0.8.3.ebuild
new file mode 100644
index 00000000000..57e54f1f15a
--- /dev/null
+++ b/www-apps/webdavcgi/webdavcgi-0.8.3.ebuild
@@ -0,0 +1,108 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=4
+
+inherit eutils toolchain-funcs webapp
+
+DESCRIPTION="A Perl CGI for accessing and sharing files, or calendar/addressbooks via WebDAV"
+HOMEPAGE="http://webdavcgi.sourceforge.net/"
+SRC_URI="mirror://sourceforge/${PN}/${P}.tar.bz2"
+
+LICENSE="GPL-3"
+SLOT="0"
+WEBAPP_MANUAL_SLOT="yes"
+KEYWORDS="~amd64"
+IUSE="mysql postgres rcs samba +sqlite +suid"
+
+DEPEND=""
+RDEPEND="dev-perl/Archive-Zip
+ dev-perl/File-Copy-Link
+ dev-perl/PerlIO-gzip
+ dev-perl/Quota
+ dev-perl/TimeDate
+ dev-perl/URI
+ dev-perl/UUID-Tiny
+ dev-perl/XML-Simple
+ media-gfx/graphicsmagick[perl]
+ mysql? ( dev-perl/DBD-mysql )
+ virtual/perl-Module-Load
+ postgres? ( dev-perl/DBD-Pg )
+ rcs? ( dev-perl/Rcs )
+ samba? ( dev-perl/Filesys-SmbClient )
+ sqlite? ( dev-perl/DBD-SQLite )
+ dev-perl/CGI
+ virtual/perl-File-Spec"
+
+need_httpd_cgi
+
+REQUIRED_USE="|| ( mysql postgres sqlite )"
+
+CGIBINDIR="cgi-bin"
+
+src_prepare() {
+ epatch "${FILESDIR}/${PV}-logout-var-expansion.patch"
+}
+
+src_compile() {
+ if use suid; then
+ # There are several webdavwrappers, TODO: make it configureable
+ export WEBDAVWRAPPER="webdavwrapper"
+
+ $(tc-getCC) ${LDFLAGS} ${CFLAGS} \
+ -o "${CGIBINDIR}/${WEBDAVWRAPPER}" \
+ helper/webdavwrapper.c || die "compile ${WEBDAVWRAPPER} failed"
+ fi
+}
+
+src_install() {
+ webapp_src_preinst
+
+ local htdocsDir='htdocs'
+ local confDir='etc'
+
+ local installDirs="$confDir lib locale"
+
+ insinto "${MY_HTDOCSDIR}"
+ doins -r "${htdocsDir}"/*
+
+ exeinto "${MY_CGIBINDIR}"
+ newexe "${CGIBINDIR}/logout-dist" logout
+
+ doexe "${CGIBINDIR}/webdav.pl"
+ use suid && doexe "${CGIBINDIR}/${WEBDAVWRAPPER}"
+
+ local currentDir
+ for currentDir in ${installDirs}; do
+ dodir "${MY_HOSTROOTDIR}/${currentDir}"
+ insinto "${MY_HOSTROOTDIR}/${currentDir}"
+ doins -r "${currentDir}"/*
+ done
+
+ webapp_configfile "${MY_HOSTROOTDIR}/${confDir}"/{webdav.conf-dist,mime.types}
+
+ use mysql && webapp_sqlscript mysql sql/mysql.sql
+ use postgres && webapp_sqlscript postgres sql/postgresql.sql
+
+ dodoc CHANGELOG TODO
+ dohtml -r doc/*
+
+ webapp_hook_script "${FILESDIR}/reconfig"
+
+ webapp_src_install
+
+ # In order to change the user and group ID at runtime, the webdavwrapper
+ # needs to be run as root (set-user-ID and set-group-ID bit)
+ if use suid; then
+ einfo "Setting SUID and SGID bit for ${WEBDAVWRAPPER}"
+ fowners root:root "${MY_CGIBINDIR}/${WEBDAVWRAPPER}"
+ fperms 6755 "${MY_CGIBINDIR}/${WEBDAVWRAPPER}"
+ webapp_postinst_txt en "${FILESDIR}/postinstall-${WEBDAVWRAPPER}-en.txt"
+ webapp_hook_script "${FILESDIR}/reconfig-suid"
+ else
+ ewarn "You have the 'suid' USE flag disabled"
+ ewarn "WebDAV CGI won't be able to switch user ids"
+ webapp_postinst_txt en "${FILESDIR}/postinstall-en.txt"
+ fi
+}
diff --git a/www-apps/webdavcgi/webdavcgi-0.8.4.ebuild b/www-apps/webdavcgi/webdavcgi-0.8.4.ebuild
new file mode 100644
index 00000000000..6b72717a039
--- /dev/null
+++ b/www-apps/webdavcgi/webdavcgi-0.8.4.ebuild
@@ -0,0 +1,164 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+inherit eutils toolchain-funcs versionator
+
+DESCRIPTION="A Perl CGI for accessing and sharing files, or calendar/addressbooks via WebDAV"
+HOMEPAGE="http://webdavcgi.sourceforge.net/"
+SRC_URI="mirror://sourceforge/${PN}/${P}.tar.bz2"
+
+LICENSE="GPL-3"
+
+# Provide slotting on minor versions. WebDAV CGI is a web application which
+# can be shared by multiple instances and thus major updates shouldn't be
+# enforced to all users/instances at the same time.
+SLOT="$(get_version_component_range 1-2)"
+
+KEYWORDS="~amd64"
+IUSE="afs kerberos mysql postgres rcs samba +sqlite +suid"
+
+DEPEND=""
+RDEPEND="!www-apps/webdavcgi:0
+ afs? ( net-fs/openafs )
+ dev-lang/perl
+ dev-perl/Archive-Zip
+ dev-perl/File-Copy-Link
+ dev-perl/PerlIO-gzip
+ dev-perl/Quota
+ dev-perl/TimeDate
+ dev-perl/URI
+ dev-perl/UUID-Tiny
+ dev-perl/XML-Simple
+ kerberos? ( virtual/krb5 )
+ media-gfx/graphicsmagick[perl]
+ mysql? ( dev-perl/DBD-mysql )
+ virtual/perl-Module-Load
+ postgres? ( dev-perl/DBD-Pg )
+ rcs? ( dev-perl/Rcs )
+ samba? ( dev-perl/Filesys-SmbClient )
+ sqlite? ( dev-perl/DBD-SQLite )
+ dev-perl/CGI
+ virtual/perl-File-Spec
+ || ( virtual/httpd-cgi virtual/httpd-fastcgi )"
+
+REQUIRED_USE="|| ( mysql postgres sqlite )"
+
+CGIBINDIR="cgi-bin"
+
+src_compile() {
+ if use suid; then
+ WEBDAVWRAPPERS="webdavwrapper" # Standard UID/GID wrapper
+
+ use afs && WEBDAVWRAPPERS+=" webdavwrapper-afs"
+ use kerberos && WEBDAVWRAPPERS+=" webdavwrapper-krb"
+
+ export WEBDAVWRAPPERS
+
+ local wrapper
+ for wrapper in ${WEBDAVWRAPPERS}; do
+ $(tc-getCC) ${LDFLAGS} ${CFLAGS} \
+ -o "${CGIBINDIR}/${wrapper}" \
+ "helper/${wrapper}.c" || die "compile ${wrapper} failed"
+ done
+ fi
+}
+
+src_install() {
+ exeinto "/usr/libexec/${PN}-${SLOT}/${CGIBINDIR}"
+ newexe "${CGIBINDIR}/logout-dist" "logout"
+ doexe "${CGIBINDIR}/webdav.pl"
+
+ use afs && doexe "${CGIBINDIR}/afswrapper"
+ use samba && doexe "${CGIBINDIR}/smbwrapper"
+
+ if use suid; then
+ # In order to change the user and group ID at runtime, the webdavwrapper
+ # needs to be run as root (set-user-ID and set-group-ID bit)
+ exeopts -o root -g root -m 6755
+
+ local wrapper
+ for wrapper in ${WEBDAVWRAPPERS}; do
+ einfo "Installing UID/GID wrapper ${wrapper}"
+ doexe "${CGIBINDIR}/${wrapper}"
+ done
+
+ # reset install opts
+ exeopts
+ else
+ ewarn "You have the 'suid' USE flag disabled"
+ ewarn "WebDAV CGI won't be able to switch user ids"
+ fi
+
+ local confDir='etc'
+ local webdavConfDir="/etc/${PN}-${SLOT}/default"
+
+ export WEBDAVCONFIG="${webdavConfDir}/webdav.conf"
+
+ insinto "${webdavConfDir}"
+ doins "${confDir}/mime.types"
+ newins "${FILESDIR}/webdav-${SLOT}.conf" "webdav.conf"
+
+ local installBaseDir="/usr/share/${PN}-${SLOT}"
+ local currentDir
+ for currentDir in htdocs lib locale; do
+ insinto "${installBaseDir}/${currentDir}"
+ doins -r "${currentDir}"/*
+ done
+
+ if use mysql || use postgres; then
+ local sqlDir='sql'
+ insinto "${installBaseDir}/${sqlDir}"
+ use mysql && "${sqlDir}/mysql.sql"
+ use postgres && "${sqlDir}/postgresql.sql"
+ fi
+
+ if use sqlite; then
+ # Directory where the SQLite database resides
+ local sqliteRootDir="/var/lib/${PN}/${SLOT}"
+ keepdir "${sqliteRootDir}"
+
+ # Default database directory where all users are able to create and
+ # share the databases, this can be changed within the config file and
+ # restricted to user/group only access if required.
+ export SQLITEDIR="${sqliteRootDir}/default"
+ keepdir "${SQLITEDIR}"
+ fperms 1777 "${SQLITEDIR}"
+ fi
+
+ # Default thumbnail directory, writable by all users
+ export THUMBNAILDIR="/var/cache/${PN}/${SLOT}/default/thumbnails"
+ keepdir "${THUMBNAILDIR}"
+ fperms 1777 "${THUMBNAILDIR}"
+
+ export APACHEEXAMPLECONFIG="apache-webdavcgi-${SLOT}-example.conf"
+ dodoc CHANGELOG TODO
+ dodoc "${FILESDIR}/${APACHEEXAMPLECONFIG}"
+ dohtml -r doc/*
+}
+
+pkg_postinst() {
+ ewarn "In order to allow different users to create and share files,"
+ ewarn "some directories were installed with world write access by default."
+ ewarn "To set restrictive permissions, add all WebDAV CGI users to a"
+ ewarn "common group, and allow access to the following directories by this"
+ ewarn "group only."
+ ewarn "Thumbnail directory: ${THUMBNAILDIR}"
+ use sqlite && ewarn "SQLite directory: ${SQLITEDIR}"
+
+ ewarn
+ ewarn "Until bug #456180 is fixed, you probably have to re-emerge"
+ ewarn "media-gfx/graphicsmagick"
+
+ elog
+ elog "The WebDAV CGI config is located at ${WEBDAVCONFIG}."
+ elog
+ elog "An example Apache HTTP server configuration snippet is available in"
+ elog "/usr/share/doc/${PF} in the file ${APACHEEXAMPLECONFIG}"
+
+ einfo
+ einfo "Detailed installation and configuration instructions can be found at"
+ einfo "http://webdavcgi.sourceforge.net/"
+}